import React, { ReactElement, useState } from 'react'
import {Row, Col, Input, Label, FormGroup} from "reactstrap"
import {FormSubmit} from "reactstrap-react-lib"

interface FORM{  age : number;  firstName : string;  DOB : string;}

interface Props{
    uri:string;
    inputsElements: FORM
}

export default function Patient(props: Props): ReactElement {
    let initialState:FORM
    if(props.inputsElements === undefined){
        let tempState:any
        Object.keys(props.inputsElements).forEach(el=>{
            tempState[el]= undefined;
        })
        initialState = tempState;
    }else{
        initialState = props.inputsElements;
    }

    const [inputObj, setInputObj] = useState(initialState)
    return (
        <>
            <FormSubmit
                Inputs = {
                    
      <>
        <Row> 
          
    <Col sm={12} md={6} lg={3}>
      <FormGroup>
          <Label>age</Label>
          <Input type="number" 
          value={inputObj.age} 
          onChange={(e)=>setInputObj({...inputObj, age :parseInt(e.target.value) })}
 
      />
      </FormGroup>
    </Col>
    
    <Col sm={12} md={6} lg={3}>
      <FormGroup>
          <Label>firstName</Label>
          <Input type="text" 
          value={inputObj.firstName} 
          onChange={(e)=>setInputObj({...inputObj, firstName :e.target.value })}
 
      />
      </FormGroup>
    </Col>
    
    <Col sm={12} md={6} lg={3}>
      <FormGroup>
          <Label>DOB</Label>
          <Input type="date" 
          value={inputObj.DOB} 
          onChange={(e)=>setInputObj({...inputObj, DOB :e.target.value })}
 
      />
      </FormGroup>
    </Col>
    
        </Row>
      </>
                }
                curUri = {props.uri}
                curObj = {["POST", inputObj]}
                onSuccess = {(res)=>res.data?.mes  === undefined ? "success" : res.data.mes}
                onError = {(err)=> err.response?.data === undefined ? "error" : err.response.data }
                reset = {()=> setInputObj(initialState)}
 
            />
        </>

    )
}