#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var inquirer_1 = __importDefault(require("inquirer"));
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var buf;
inquirer_1.default.prompt([
    {
        type: "list",
        message: "Choose Language",
        name: "language",
        choices: ["Typescript"]
        // choices : ["Typescript", "Javascript"]
    },
    {
        type: "list",
        message: "Choose Form",
        name: "form",
        choices: ["FormSubmit"]
        //  choices : ["FormSubmit", "FormDelete", "Table", "Admin Panel"]
    }
]).then(function (answer) {
    var filepath;
    if (answer.language == 'Typescript' && answer.form == 'FormSubmit') {
        filepath = path_1.default.resolve(__dirname, "../src/assets/typescript/FormSubmit.tsx");
        buf = fs_1.default.readFileSync(filepath).toString();
        // wrun inque=re here
        inquirer_1.default.prompt([
            {
                "type": "input",
                "name": "FormName",
                "message": "Name of the component"
            }
        ]).then(function (ans) {
            buf = buf.replace("Example", ans.FormName);
            inputLoop("", "", buf);
        }).catch(function (err) { return console.log(err); });
    } //if(answer.language == 'Typescript' && answer.form=='FormSubmit' )
});
var inputLoop = function (inputStr, interfaceString, buf) {
    inquirer_1.default.prompt([{
            "type": "input",
            "name": "field"
        }, {
            "type": "list",
            "name": "InputType",
            "choices": [
                'text',
                'number',
                'email',
                'password',
                'select',
                'file',
                'radio',
                'checkbox',
                'textarea',
                'date',
                'datetime-local',
                'hidden',
                'image',
                'month',
                'range',
                'search',
                'tel',
                'url',
                'week',
                'datetime',
                'time',
                'color',
            ]
        },
        {
            "type": "list",
            "name": "continue",
            "message": "Should we continue to add more fields?",
            "choices": ["Yes", "No"]
        }]).then(function (ans) {
        inputStr = inputStr + "\n    <Col sm={12} md={6} lg={3}>\n      <FormGroup>\n          <Label>" + ans.field + "</Label>\n          <Input type=\"" + ans.InputType + "\" \n          value={inputObj." + ans.field + "} \n          onChange={(e)=>setInputObj({...inputObj, " + ans.field + " :" + (createInterFace(ans.InputType) == "number" ? 'parseInt(e.target.value)' : 'e.target.value') + " })}\n \n      />\n      </FormGroup>\n    </Col>\n    ";
        interfaceString = interfaceString + "  " + ans.field + " : " + createInterFace(ans.InputType) + ";";
        if (ans.continue == "Yes") {
            inputLoop(inputStr, interfaceString, buf);
        }
        else {
            buf = buf.replace("<><Row></Row></>", "\n      <>\n        <Row> \n          " + inputStr + "\n        </Row>\n      </>");
            buf = buf.replace("interface FORM{name:string}", "interface FORM{" + interfaceString + "}");
            fs_1.default.writeFileSync("Form.tsx", buf);
        }
    }); //end of then
};
var createInterFace = function (inputType) {
    var cur = {
        'text': "string",
        'number': "number",
        'email': "string",
        'password': "string",
        'select': "any",
        'file': "any",
        'radio': "any",
        'checkbox': "string",
        'textarea': "string",
        'date': "string",
        'datetime-local': "string",
        'hidden': "string",
        'image': "any",
        'month': "any",
        'range': "any",
        'search': "string",
        'tel': "any",
        'url': "string",
        'week': "string",
        'datetime': "string",
        'time': "string",
        'color': "string",
    };
    var ret = "";
    Object.keys(cur).forEach(function (el) { return el == inputType ? ret = cur[el] : ""; });
    return ret;
};
//# sourceMappingURL=index.js.map